Bug 959029 - Review Request: ascii-design - A tool to create ascii arts
Summary: Review Request: ascii-design - A tool to create ascii arts
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Björn 'besser82' Esser
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-05-03 03:04 UTC by Christopher Meng
Modified: 2014-01-21 13:58 UTC (History)
5 users (show)

Fixed In Version: ascii-design-1.0.1-2.fc18
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-21 20:36:47 UTC
Type: ---
besser82: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Christopher Meng 2013-05-03 03:04:34 UTC
Spec URL: http://cicku.me/ascii-design.spec
SRPM URL: http://cicku.me/ascii-design-1.0.1-1.fc20.src.rpm

Description: Ascii Design is a free program based on figlet engine that enables you to 
create awesome ascii art text. You can create art based text for many types 
of decorations for web sites, e-mail, text files etc...
Ascii Design is also able to use dozens of special fonts to create various 
styles of ascii arts.

Fedora Account System Username: cicku

Comment 1 Christopher Meng 2013-05-03 03:16:43 UTC
Koji success:

http://koji.fedoraproject.org/koji/taskinfo?taskID=5327044

Comment 2 Mario Blättermann 2013-05-03 08:24:30 UTC
Your package looks almost fine. Just one warning from rpmlint:

ascii-design.spec:12: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 12)
The specfile mixes use of spaces and tabs for indentation, which is a cosmetic
annoyance.  Use either spaces or tabs for indentation, not both.



$ rpm -qpR *6.rpm
figlet
libQtCore.so.4
libQtGui.so.4
libc.so.6
libc.so.6(GLIBC_2.0)
libc.so.6(GLIBC_2.1.3)
libgcc_s.so.1
libgcc_s.so.1(GCC_3.0)
libm.so.6
libpthread.so.0
libstdc++.so.6
libstdc++.so.6(CXXABI_1.3)
libstdc++.so.6(GLIBCXX_3.4)
qt
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rtld(GNU_HASH)
rpmlib(PayloadIsXz) <= 5.2-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(PayloadIsXz) <= 5.2-1

Qt as an explicite requirement is redundant, rpm picks it up automatically due to system calls during the compilation. Please drop it from Requires.

Comment 3 Björn 'besser82' Esser 2013-05-18 06:20:50 UTC
mock-build fails:

Executing(%prep): /bin/sh -e /var/tmp/rpm-tmp.HSEZuG
+ umask 022
+ cd /builddir/build/BUILD
+ cd /builddir/build/BUILD
+ rm -rf ascii-design-1.0.1
+ /usr/bin/bzip2 -dc /builddir/build/SOURCES/ascii-design-1.0.1.tar.bz2
+ /usr/bin/tar -xf -
+ STATUS=0
+ '[' 0 -ne 0 ']'
+ cd ascii-design-1.0.1
+ /usr/bin/chmod -Rf a+rX,u+w,g-w,o-w .
+ dos2unix COPYING.TXT
/var/tmp/rpm-tmp.HSEZuG: line 37: dos2unix: command not found
RPM build errors:
error: Bad exit status from /var/tmp/rpm-tmp.HSEZuG (%prep)
    Bad exit status from /var/tmp/rpm-tmp.HSEZuG (%prep)
Child return code was: 1
EXCEPTION: Command failed.

--> BuildRequires: dos2unix

As Mario stated in #2 remove Requires: qt, please.

and:

rpmlint 959029-ascii-design/srpm/ascii-design*
ascii-design.src: W: spelling-error %description -l en_US figlet -> filet, fillet, piglet // ignored
ascii-design.src:12: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 12)
959029-ascii-design/srpm/ascii-design.spec:12: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 12)
1 packages and 1 specfiles checked; 0 errors, 3 warnings.

Comment 4 Christopher Meng 2013-05-18 07:19:48 UTC
(In reply to comment #3)

Hey,

Unfortunately, I forgot to upload the latest spec.

Spec URL: http://cicku.me/ascii-design.spec
SRPM URL: http://cicku.me/ascii-design-1.0.1-2.fc20.src.rpm

Comment 5 Björn 'besser82' Esser 2013-05-18 10:36:12 UTC
Just one litte thing:

BuildRequires:     desktop-file-utils
BuildRequires:     dos2unix
- Requires:          figlet
+ Requires:          figlet%{?_isa}

%description

fix this in SCM, please.

rest is fine:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- update-desktop-database is invoked when required
  Note: desktop file(s) in ascii-design
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[-]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments). ---> figlet --> should be figlet%{?_isa} // fix this in SCM !!!!!
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ascii-design-1.0.1-2.fc20.x86_64.rpm
ascii-design.x86_64: W: no-manual-page-for-binary ascii-design
1 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ascii-design
ascii-design.x86_64: W: no-manual-page-for-binary ascii-design
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
ascii-design (rpmlib, GLIBC filtered):
    figlet <-- should be figlet%{?_isa}
    libQtCore.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)



Provides
--------
ascii-design:
    ascii-design
    ascii-design(x86-64)



Source checksums
----------------
http://downloads.sourceforge.net/project/ascii-design/ascii-design/Ascii-Design 1.0.1/ascii-design-1.0.1.tar.bz2 :
  CHECKSUM(SHA256) this package     : 24b741f11236ed1be0832cd6418f84f769e5323c44495790d2178c008911ca48
  CHECKSUM(SHA256) upstream package : 24b741f11236ed1be0832cd6418f84f769e5323c44495790d2178c008911ca48


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 959029

And so another one:

APPROVED!

Comment 6 Christopher Meng 2013-05-18 10:39:21 UTC
I don't understand why I should add %{?_isa}?

Any explanation?

Comment 7 Björn 'besser82' Esser 2013-05-18 11:00:28 UTC
figlet is an arch-dependend package. %{?_isa} makes sure the dependency will eval to the correct-arch, so there will be no mess-up on multi-arch.

Currently Requires are:

ascii-design (rpmlib, GLIBC filtered):
    figlet
    libQtCore.so.4()(64bit)
    ...

So if you habe figlet.i686 installed on x86_64, dependency will be met for yum/rpm, but this is not what you usually desire and may/will result in unexpected behaviour or maybe crash...

if you change Requires: figlet --> figlet%{?_isa}

Requires of build-rpm will be:

ascii-design (rpmlib, GLIBC filtered):
    figlet(64bit)
    libQtCore.so.4()(64bit)
    ...

So this makes sure dependency is the same arch the rpm was build for and things will go fine for sure.

Comment 8 Christopher Meng 2013-05-18 11:54:48 UTC
But if like you said, should we add %{?_isa} to all deps(without noarch packages) because of such silly habit?

Comment 9 Björn 'besser82' Esser 2013-05-18 12:17:41 UTC
This only needed in the explicitly named Requires, if they are arch-dependend. Auto-Requires from rpmbuild do respect _isa on their own.

On BuildRequires you must NOT use _isa-macro, because BuildRequires will become Requires of SRPM and so build is performed against the arch which was used to generate SRPM or possibly will fail...

Comment 10 Christopher Meng 2013-05-18 12:54:31 UTC
(In reply to comment #9)

I don't understand your meaning very well...

Why so many requires some pacakges without this flag?

Can you tell me a reason why should I add this for this package?

Thanks.

Comment 11 Björn 'besser82' Esser 2013-05-18 13:09:10 UTC
From http://www.rpm.org/wiki/PackagerDocs/ArchDependencies:

[quote]
Architecture-specific Dependencies

On multiarch systems such as x86_64 it would be often desireable to express that a package of compatible architecture is needed to satisfy a dependency. In most of the cases this is already handled by the automatically extracted soname dependencies, but this is not always the case: sometimes it's necessary to disable the automatic dependency generation, and then there are cases where the information cannot be automatically generated, such as -devel package dependencies on other -devel packages and build dependencies. Consider the following:

Name: foo
...
BuildRequires: libbar-devel >= 2.2

%package devel
Requires: libbar-devel >= 2.2
...

This works fine on single-arch systems such as i386, but it's not sufficient on multiarch systems: when building a 32bit package on a 64bit system, a 32bit version of the libbar-devel would be needed, but the above lets libbar-devel.x86_64 satisfy the build dependency too, leading to obscure build failure. Similarly a 32bit libbar-devel would incorrectly satisfy the dependency for a 64bit package.
ISA Dependencies

In rpm 4.6.0, the concept of ISA (Instruction Set Architecture) was introduced to permit differentiating between 32- and 64-bit versions without resorting to file dependencies on obscure and/or library-version dependent paths. To declare a dependency on a package name architecture specific, append %{?_isa} to the dependency name, eg

Requires: libbar-devel%{?_isa} >= 2.2

This will expand to libbar-devel(archfamily-bitness) depending on the build target architecture, for example a native build on x86_64 would give

Requires: libbar-devel(x86-64) >= 2.2

but with --target i386 (or i586, i686 etc) it would become

Requires: libbar-devel(x86-32) >= 2.2
[/quote]

> Why so many requires some pacakges without this flag?

They were problay created in times of rpm <= 4.6.0 and maintainer didn't fix, yet.

Can you tell me a reason why should I add this for this package?

The for adding the isa-macro (figlet%{?_isa}) is it's a new package, rpm is >= 4.6.0 and it will prevent trouble for users installing it on multi-arch when having figlet != %{_isa} already installed.

Comment 12 Rex Dieter 2013-05-18 13:44:57 UTC
I'd argue against an arch'd figlet%{?_isa} dependency.

1.  figlet is simply as an external binary tool (in /usr/bin), so it's arch does not matter really (a non-native arch'd tool could work just as well).  That is, unless there is some non-obvious reason that makes a native arch figlet work better in this case?

2.  it does not matter, the figlet package is not multilib'd, so only the native arch pkg will ever be available anyway.  Much ado about nothing.  :)

Comment 13 Björn 'besser82' Esser 2013-05-18 13:58:34 UTC
I didn't consider this a blocker, as I already granted fedora-review(+) in #5: https://bugzilla.redhat.com/show_bug.cgi?id=959029#c5

I just did `yum list figlet` and noticed that it is an arched-pkg. I think using %{?_isa} on explicit arched Requires is good practice and suggested adding it.

It's up to Christopher to decide whether he adds it or not; "fix this in SCM,please" was more meant a suggestion than a request... ;)

Comment 14 Michael Schwendt 2013-05-18 19:50:18 UTC
Re: comment 2

> Qt as an explicite requirement is redundant, rpm picks it up
> automatically due to system calls during the compilation.

More correctly, rpm-build examines the built files (installed into the %buildroot) in its "find-requires" step. For example, from executables and libs it extracts the library SONAMEs the files are linked with.

Comment 15 Christopher Meng 2013-05-20 23:49:13 UTC
New Package SCM Request
=======================
Package Name: ascii-design
Short Description: A tool to create ascii arts
Owners: 
Branches: f18 f19
InitialCC:

Comment 16 Gwyn Ciesla 2013-05-21 11:07:11 UTC
No owners specified.

Comment 17 Christopher Meng 2013-05-21 11:18:39 UTC
New Package SCM Request
=======================
Package Name: ascii-design
Short Description: A tool to create ascii arts
Owners: cicku
Branches: f18 f19
InitialCC:

Comment 18 Gwyn Ciesla 2013-05-21 12:02:09 UTC
Git done (by process-git-requests).

Comment 19 Fedora Update System 2013-05-22 01:07:56 UTC
ascii-design-1.0.1-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ascii-design-1.0.1-2.fc19

Comment 20 Fedora Update System 2013-05-22 01:16:45 UTC
ascii-design-1.0.1-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ascii-design-1.0.1-2.fc18

Comment 21 Fedora Update System 2013-05-30 03:39:02 UTC
ascii-design-1.0.1-2.fc19 has been pushed to the Fedora 19 stable repository.

Comment 22 Fedora Update System 2013-06-01 02:27:30 UTC
ascii-design-1.0.1-2.fc18 has been pushed to the Fedora 18 stable repository.

Comment 23 Christopher Meng 2014-01-21 03:31:14 UTC
Package Change Request
======================
Package Name: ascii-design
New Branches: epel7
Owners: cicku

Comment 24 Gwyn Ciesla 2014-01-21 13:58:31 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.